using System;

using Windows.Foundation.Metadata;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Media.Animation;
using Microsoft.UI.Xaml.Navigation;

namespace TestProject
{
    /// <summary>
    /// ÷ 
    /// </summary>
    public sealed partial class CollectionPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ŀ  ü
        /// </summary>
        private CustomDataObject customDataObject;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - CollectonPage()

        /// <summary>
        /// 
        /// </summary>
        public CollectionPage()
        {
            InitializeComponent();

            NavigationCacheMode = NavigationCacheMode.Enabled;

            this.listView.ItemsSource = CustomDataObject.GetCustomDataObjectList();

            this.listView.Loaded    += listView_Loaded;
            this.listView.ItemClick += listView_ItemClick;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Ʈ  ε óϱ - listView_Loaded(sender, e)

        /// <summary>
        /// Ʈ  ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private async void listView_Loaded(object sender, RoutedEventArgs e)
        {
            if(customDataObject != null)
            {
                this.listView.ScrollIntoView(this.customDataObject, ScrollIntoViewAlignment.Default);

                this.listView.UpdateLayout();

                ConnectedAnimation animation = ConnectedAnimationService.GetForCurrentView().GetAnimation("BackConnectedAnimation");

                if(animation != null)
                {
                    if(ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 7))
                    {
                        animation.Configuration = new DirectConnectedAnimationConfiguration();
                    }

                    await this.listView.TryStartConnectedAnimationAsync(animation, customDataObject, "image");
                }

                this.listView.Focus(FocusState.Programmatic);
            }
        }

        #endregion
        #region Ʈ  ׸ Ŭ óϱ - listView_ItemClick(sender, e)

        /// <summary>
        /// Ʈ  ׸ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void listView_ItemClick(object sender, ItemClickEventArgs e)
        {
            if(this.listView.ContainerFromItem(e.ClickedItem) is ListViewItem container)
            {
                this.customDataObject = container.Content as CustomDataObject;

                this.listView.PrepareConnectedAnimation("ForwardConnectedAnimation", this.customDataObject, "image");
            }

            Frame.Navigate(typeof(DetailPage), this.customDataObject, new SuppressNavigationTransitionInfo());
        }

        #endregion
        #region  ؽƮ  ؽƮ Ʈ  óϱ - descriptionTextBlock_IsTextTrimmedChanged(sender, e)

        /// <summary>
        ///  ؽƮ  ؽƮ Ʈ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void descriptionTextBlock_IsTextTrimmedChanged(TextBlock sender, IsTextTrimmedChangedEventArgs e)
        {
            TextBlock textBlock = sender as TextBlock;

            string text = textBlock.IsTextTrimmed ? textBlock.Text : string.Empty;

            ToolTipService.SetToolTip(textBlock, text);
        }

        #endregion
    }
}